#!/bin/csh -f
# Usage: make-NC-RST.com

#############################################
# USER DEFINED VARIABLES
set cyana_rdc=../../cyana/b.ori
set pdb=../1.prep/amber.pdb
set total_rdcs=42
set range1=0
set range2=2

# Renumber cyana.ori file
set startmol1=283
set endmol1=298
set startmol2=683
set endmol2=698

###############################################
###  Header and Footer Information for DIP file
cat << eof > temp.header
 &align
   ndip=$total_rdcs, dcut=-1.0, 
   dwt=$total_rdcs*1.0, gigj = $total_rdcs*7.8467, dij=$total_rdcs*1.09,
   s11= 0.000, s12= 0.000, s13= 0.000, s22= 0.000, s23= 0.000, 
   freezemol= .false., 
   freezes= .false.,
eof

cat << eof2 > temp.footer
 &end
eof2
##############################################
   set sub1=`expr $startmol1 - 1`
   set sub2=`expr $startmol2 - $endmol2 + $startmol2 - 2`

cp $pdb ./amber.pdb
cp $cyana_rdc ./cyana.rdc

   renumbercyanaori.pl -$sub1 $startmol1 $endmol1 ./cyana.rdc > temp1.rdc
   renumbercyanaori.pl -$sub2 $startmol2 $endmol2 ./temp1.rdc > temp2.rdc
   prepori2pales.pl -s 0 1 1000 ./temp2.rdc > temp3.ori
   ori2pales.pl ./temp3.ori  > ./pales.rdc
   grep -v 'VAR' ./pales.rdc | \
   grep -v 'FORMAT'          > pales-clean.rdc

#########################################

# - Make the Amber DIP input file
    makeDIP_RST.pales_rna pales-clean.rdc ./amber.pdb $range1
    cat temp.header RST.dip temp.footer > DIP$range1.RST

#    makeDIP_RST.pales_rna pales-clean.rdc ./amber.pdb $range2
#    cat temp.header RST.dip temp.footer > DIP$range2.RST

# - Clean up
   /bin/rm temp* prep* mod* pales* *bkp RST.dip cyana.rdc RST.ang amber.pdb

echo
echo Done
echo
