#!/usr/bin/perl

####PERL SCRIPT to extract data from .out files############  
#####and to plot xy scatter plots##########################
###Plots are separate showing RDC scatter, RCSA scatter####
########and RDC and RCSA on the same plot##################
####Written by Holly R. Summers 9/24/2008################## 
########UMBC, Dept. of Chemistry###########################
####Modified HRS 11/14/08###################################
###########################################################

####Request single or multiple OUT file input#######
print "Would you like to open a single(S) OUT file in this directory or multiple(M) OUT files? \n";
$input = <STDIN>;
#print "$input \n";

######Single OUT File input######
if($input =~ /S/) {
print "Input name of OUT file to plot \n";
$nameinput = <STDIN>;
$fileout=$nameinput;

#prints to screen file being read into script
print $fileout;

#opens out files
open (COMFILE, "< $fileout");

#opens output files for data to be plotted
open (PLOTOUT, ">> PLOTfileRDC.csa");
open (PLOTOUT2, ">> PLOTfileRCSA.csa");

#reads in data from out files
while (<COMFILE>) {
($Cskip, $atomskip2, $numskip, $dashskip, $resskip, $atom2skip, $num2skip, $curval, $tarval, $devskip, $penskip, $disskip) = split;
#searches arrays for desired data
if ($Cskip =~ /   /){
next
}
#selects proper outfile to put data to be plotted in
if ($Cskip =~ /C.*/) {
if ($resskip =~ /H.*/) {
printf PLOTOUT "$curval, $tarval \n";}
if ($dashskip=~ /:/) {
printf PLOTOUT2 "$resskip, $atom2skip \n";
}
}
}
}
#print "$input \n";
#####Multiple File Input#######
if ($input=~ /M/) {
#Opens directory 
###############Note: WILL FIND .OUT FILES IN CURRENT DIRECTORY#######
opendir(OUT, "./")||die "ERROR: can not read current directory\n";
#Read in filenames in directory
@thefiles=readdir(OUT);
#Closes Directory
closedir(OUT);

#sets up loop to read in selected files from directory (.out files)
foreach $f (@thefiles){
if ($f =~ / *.out/){
$fileout=$f;

#print "$input \n";

#prints to screen files being read into script
print $fileout;

#opens out files
open (COMFILE, "< $fileout");

#opens output files for data to be plotted
open (PLOTOUT, ">> PLOTfileRDC.csa");
open (PLOTOUT2, ">> PLOTfileRCSA.csa");

#reads in data from out files
while (<COMFILE>) {
($Cskip, $atomskip2, $numskip, $dashskip, $resskip, $atom2skip, $num2skip, $curval, $tarval, $devskip, $penskip, $disskip) = split;
#searches arrays for desired data
if ($Cskip =~ /   /){
next
}
#selects proper outfile to put data to be plotted in
if ($Cskip =~ /C.*/) {
if ($resskip =~ /H.*/) {
printf PLOTOUT "$curval, $tarval \n";}
if ($dashskip=~ /:/) {
printf PLOTOUT2 "$resskip, $atom2skip \n";
}
}
}
}
}
}

#closes input and output files
close (COMFILE);
close (PLOTOUT);
close (PLOTOUT2);

########GNUPLOT for RDC data to xyscatterRCA.ps file##############
open GNUPLOT, "| gnuplot";
print GNUPLOT <<gnuplot_commands;
#Script to do scatter plot with RDC data from .out files
#Set terminal POSTSCRIPT and to have solid lines and color
set terminal postscript solid color
#Set output file
set output 'xyscatterRDC.ps'
#title of scatter plot
set title "RDC PLOT calculated value vs. experimental value"
#x axis label
set xlabel "RDC experimental"
#y axis label
set ylabel "RDC calculated"
#show ylabel
#allows plots to be on same graph
set multiplot
#makes the unit length for the x axis the same as the yaxis
#set size ratio -1
#sets point size
set pointsize 1.0
#remembers x and y range on axis
set xrange [] writeback
set yrange [] writeback
#draws scatter plot with purple points
plot 'PLOTfileRDC.csa' with points lt 4
#####draws line x=y in green########
#restores x and y range for the second plot
set xrange restore
set yrange restore
#shows ranges of x and y axis
#show xrange
#show yrange
#Plots x=y
replot x lt 2
gnuplot_commands
close GNUPLOT;

######GNUPLOT for RCSA data to xyscatterRCSA.ps file###############
open GNUPLOT, "| gnuplot";
print GNUPLOT <<gnuplot_commands;
#Script to do scatter plot with RCSA data from.out file
#Set terminal Postcript
set terminal postscript solid color
#Set output file
set output 'xyscatterRCSA.ps'
#title of scatter plot
set title "RCSA PLOT calculated value vs. experimental value"
#x axis label
set xlabel "RCSA experimental"
#show xlabel
#y axis label
set ylabel "RCSA calculated"
#show ylabel
#allows plots to be on same graph
set multiplot
#sets point size
set pointsize 1.0
set xrange [] writeback
set yrange [] writeback
#draws scatter plot with purple points
plot 'PLOTfileRCSA.csa' with points lt 1
#draws line x=y in green
set xrange restore
set yrange restore
#show xrange
#show yrange
replot x lt 2
gnuplot_commands
close GNUPLOT;

########GNUPLOT for RDC and RCSA data to xyscatterRDC_RCSA.ps file##############
open GNUPLOT, "| gnuplot";
print GNUPLOT <<gnuplot_commands;
#Set terminal Postcript
set terminal postscript solid color
#Script to do scatter plot with RDC data from .out files
#Set output file
set output 'xyscatterRDC_RCSA.ps'
#set autoscale
#title of scatter plot
set title "RDC and RCSA PLOT calculated value vs. experimental value"
#x axis label
set xlabel "RDC(purple) and RCSA(red) experimental"
#y axis label
set ylabel "RDC(purple) and RCSA(red) calculated"
#show ylabel
#allows plots to be on same graph
set multiplot
#sets point size
set pointsize 1.0
#remembers x and y range on axis
set xrange [] writeback
set yrange [] writeback
######draws RDC scatter plot with purple points
plot 'PLOTfileRDC.csa' with points lt 4
#Script to do scatter plot with RCSA data from.out file
#x axis label
#set xlabel "RCSA experimental"
#show xlabel
#y axis label
#set ylabel "RCSA calculated"
#show ylabel
#allows plots to be on same graph
#set multiplot
#sets point size
set pointsize 1.0
set xrange restore
set yrange restore
#draws RCSA scatter plot with red points
replot 'PLOTfileRCSA.csa' with points lt 1
#####draws line x=y in green########
#restores x and y range for the third plot
set xrange restore
set yrange restore
#shows ranges of x and y axis
#show xrange
#show yrange
#Plots x=y
replot x lt 2
gnuplot_commands
close GNUPLOT;

