#!/usr/bin/perl 
if ($#ARGV ne 3) { die "
Converts CYANA.aco to AMBER.ang file that can be read by makeANG_RST
Renumbers residues and removes all blanks and comments

USAGE: UMBC-aco2ang.pl -319 320 340 cyana.aco   subtr 319 from residues 320-340

     -319  value to be added to residue number
      320  first residue number to be changed
      340  last residue number to be changed

\n";
} 

$value = $ARGV[0];
$begin = $ARGV[1];
$end   = $ARGV[2];
$file  = $ARGV[3];

#print "$value $begin $end $file debugger \n";  exit;

open(IN, $file) or die "Can't open $file\n";          #open upl file
while (<IN>) {
    $_ =~ s/^\s+//;                 #remove trailing blanks
    if (/^[0-9]/) {                 #if line starts with a digit
	@v = split(' ', $_);        #split by space

	$v[0] = $v[0] + $value if ($v[0] >= $begin and $v[0] <= $end);
	$v[3] = $v[3] + $value if ($v[3] >= $begin and $v[3] <= $end);

	printf "%3s %3s %-4s", $v[0], $v[1], $v[2]; 
	printf "%7s %3s ", $v[3], $v[4]; 


	if ($#v > 7) {                # there are comments
	    $i=9;                     # 7th is #
	    while ($i <= $#v) {
	        print "$v[$i] ";
		$i++;
	    }
	}

	print "\n";
    }
}
close(IN);


