#!/usr/bin/perl -w
if ($#ARGV < 0) { die "
USAGE:  appendZN.pl file.pdb

 amber likes the ZN to be just before it's corresponding TER of the pdb file
 this is project specific

\n";
}             

$file = $ARGV[0];
$z=0; 			#initilize index for ZN line array;

### define the original ZN line values to be replace;
$zn1=28;
$zn2=49;
### define the ZN line values to replace to;
$toReplace1=56;
$toReplace2=57;

open(IN, $file) or die "can't open file";
while (<IN>) {
    if(/ZN/) {
        $zn[$z] = $_;                      #grep ZN;
        $z++;                              #put ZN lines in an array;
        $hasZN = 1;                        #mark this molecule has ZN lines; 
    } elsif (/TER/) {			   #the first TER after ZN line;
        if ( $hasZN ) {			   #if this molecule has ZN line;
            chgZN();  			   #then, change the lines, and print out before TER;
            $hasZN = 0;			   #now reset to no ZN line in molecule;
        }
        print $_;			   #print TER line
    } else {
        print $_;			   #no matches, just print the original lines;
    }
}
close(IN);

### subroutine to change and print ZN lines;
sub chgZN {
    foreach $line (@zn) {             
    $line =~ s/CYX     $zn1/ZN      $toReplace1/;
    $line =~ s/CYX     $zn2/ZN      $toReplace2/;
    print $line;
    }     
}
