#!/usr/bin/perl 
if ($#ARGV ne 4) { die "
Generates amber.ual file from cyana lower limit file by creating a new upper
    limit column (= lol + 1.0 A)
USAGE 1: renumberupl.pl 344  1 95 1.0 uplfile   add 344 to residues 1-95,
                                                create upl = lol + 1.0 A 

USAGE 2: renumberupl.pl -344 1 95 0.1 uplfile   subtr 344 from residues 1-95,
                                                create upl = lol + 0.1 A
       
      344  value to be subtracted or added
        1  beginning of residue number to be changed
       95  ending residue number to be changed
       1.0 value added to lower limit to create new upper limit restraint

\n";
} 

$value = $ARGV[0];
$begin = $ARGV[1];
$end   = $ARGV[2];
$delta = $ARGV[3];
$file  = $ARGV[4];

#print "$value $begin $end $file debugger \n";  exit;

open(IN, $file) or die "Can't open $file\n";          #open upl file
while (<IN>) {
    $_ =~ s/^\s+//;                 #remove trailing blanks
    if (/^[0-9]/) {                 #if line starts with a digit
	@v = split(' ', $_);        #split by space

	$v[0] = $v[0] + $value if ($v[0] >= $begin and $v[0] <= $end);
	$v[3] = $v[3] + $value if ($v[3] >= $begin and $v[3] <= $end);
        $v[7] = $v[6] + $delta;

	printf "%3s %3s %-4s", $v[0], $v[1], $v[2]; 
	printf "%7s %3s %3s %-4s ", $v[3], $v[4], $v[5], $v[6]; 
	printf "%10s", $v[7];

        print "   #   ";

	if ($#v > 7) {                # there are comments
	    $i=9;                     # 7th is #
	    while ($i <= $#v) {
	        print "$v[$i] ";
		$i++;
	    }
	}

	print "\n";
    } else {
	print;    # print lines that do not start with a digit unmodified
                  # these are the comments
    }
}
close(IN);


