#!/usr/bin/perl

#Modified and changed 9/8/2008 Holly Summers

# If no arguments when program is executed, program quits with message
if ($#ARGV < 0) { die "
#$0 is the program trying to be executed
USAGE: $0 [ramah rcsa input file] [Amber PDB file] [Range - optional]

\n"
};

# First argument in runfile which is Ramah.csa file
$csafile = $ARGV[0];
# Opening Ramah.rcsa file
# CSA is file in memory. This is the copy to be worked on
# $csafile is hard copy of file
open (CSA, $csafile);

# Second argument in runfile which is the Amber PDB file
$pdbfile = $ARGV[1];
# Opening Amber PDB file
open (PDB, $pdbfile);

# Third argument which is the range (not file and optional)
$range = $ARGV[2];

# Creating Output files
open (CSAOUT, ">RST1.csa");

######G-C8######################################N7(+2)###N9(-1)#####################################

$tot = 0;
# while:Is a loop command for Input Ramah CSA string variables
while (<CSA>)  {
($Cskip, $atom2, $res, $nameskip, $csa) = split;

# skip lines that begin with #(comments)
if ( $res =~ /#.*/ ) {
next;
}
# now if atom2 matches C8, then name corresponding atom1 (C8,
# otherwise skip to next atom
if ( $atom2 =~ /C(8)/ and $nameskip =~ /RG/ ) {
$atom1 = "C$1";

} else {
next;
}

# seek: clear the end-of-file condition and change the access position for an open channel
seek PDB,0,0;
# If first argument succeeds, the second will never be executed    
if (($atom1 eq "C8") || ($atom2 eq "C8"))  {
#look: display lines beginning with a given string
#while: is a loop command for input of Amber PDB string variables
LOOK: while (<PDB>)  { 
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "C8")  {
# First variable in output file is the atom number  
$c = $atomnum;
}
}
}
}
# Second variable in output file as first atom coordinate derived from the PDB file
#$n7 = $c + 2;
seek PDB,0,0;
LOOK: while (<PDB>) {
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "N7"){
$n7=$atomnum;
}
}
}
# Third variable in output file as the second atom coordinate derived from the PDB file
#$n9 = $c - 1;
seek PDB,0,0;
LOOK: while (<PDB>) {
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "N9"){
$n9=$atomnum;
}
}
}

# Tot Keeps track of the restraint number  
$tot++;

# printout to the CSA output file
printf CSAOUT "  jcsa(%d)=%d, icsa(%d)=%d, kcsa(%d)=%d, cobsl(%d)= %5.2f, cobsu(%d)= %5.2f, \n",
$tot, $c, $tot, $n7, $tot, $n9, $tot, ($csa-$range), $tot, ($csa+$range);
}
$gc8=$tot;
######A-C8##################################N7(+2)####N9(-1)########################################


# seek: clear the end-of-file condition and change the access position for an open channel
seek CSA,0,0;


# Input Ramah CSA variables
while (<CSA>)  {
($Cskip, $atom2, $res, $nameskip, $csa) = split;

# skip lines that begin with #(comments)
if ( $res =~ /#.*/ ) {
next;
}
# now if atom2 matches C8, then name corresponding atom1,
# otherwise skip to next atom 
if ( $atom2 =~ /C(8)/ and $nameskip =~ /RA/ ) {
$atom1 = "C$1";

} else {
next;
}

seek PDB,0,0;

# If first argument succeeds, the second will never be executed 
if (($atom1 eq "C8") || ($atom2 eq "C8"))  {
LOOK: while (<PDB>)  { 
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "C8")  {
# First variable in output file is the atom number  
$c = $atomnum;
}
}
}
}
# Second variable in output file as first atom coordinate derived from the PDB file
#$n7 = $c + 2;
seek PDB,0,0;
LOOK: while (<PDB>) {
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "N7"){
$n7=$atomnum;
}
}
}
# Third variable in output file as the second atom coordinate derived from the PDB file
#$n9 = $c - 1;
seek PDB,0,0;
LOOK: while (<PDB>) {
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "N9"){
$n9=$atomnum;
}
}
}

$tot++;

printf CSAOUT "  jcsa(%d)=%d, icsa(%d)=%d, kcsa(%d)=%d, cobsl(%d)= %5.2f, cobsu(%d)= %5.2f, \n",
$tot, $c, $tot, $n7, $tot, $n9, $tot, ($csa-$range), $tot, ($csa+$range);
}
$ac8=$tot-$gc8;
$allc8=$ac8+$gc8;

#####A-C2######################################H2(+1)###N1(-1)######################################


seek CSA,0,0;


# Input Ramah CSA variables
while (<CSA>)  {
($Cskip, $atom2, $res, $nameskip, $csa) = split;

# skip lines that begin with #(comments)
if ( $res =~ /#.*/ ) {
next;
}
# now if atom2 matches C2, then name corresponding atom1,
# otherwise skip to next atom 
if ( $atom2 =~ /C(2)/ and $nameskip =~ /RA/ ) {
$atom1 = "C$1";

} else {
next;
}

seek PDB,0,0;

# If first argument succeeds, the second will never be executed  
if (($atom1 eq "C2") || ($atom2 eq "C2"))  {
LOOK: while (<PDB>)  { 
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "C2")  {
# First variable in output file is the atom number  
$c = $atomnum;
}
}
}
}
# Second variable in output file as first atom coordinate derived from the PDB file
#$h2 = $c + 1;
seek PDB,0,0;
LOOK: while (<PDB>) {
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "H2"){
$h2=$atomnum;
}
}
}
# Third variable in output file as the second atom coordinate derived from the PDB file
#$n1 = $c - 1;
seek PDB,0,0;
LOOK: while (<PDB>) {
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "N1"){
$n1=$atomnum;
}
}
}

$tot++;

printf CSAOUT "  jcsa(%d)=%d, icsa(%d)=%d, kcsa(%d)=%d, cobsl(%d)= %5.2f, cobsu(%d)= %5.2f, \n",
$tot, $c, $tot, $h2, $tot, $n1, $tot, ($csa-$range), $tot, ($csa+$range);
}
$allc2=$tot-$allc8;

######C-C6###############################C5(+2)####C4(+4)##########################################
#close(CSAOUT);

seek CSA,0,0;

#Appends to CSA output file
#open (CSAOUT, ">>RST.csa");

# Input Ramah CSA variables
while (<CSA>)  {
($Cskip, $atom2, $res, $nameskip, $csa) = split;

# skip lines that begin with #(comments)
if ( $res =~ /#.*/ ) {
next;
}
# now if atom2 matches C6, then name corresponding atom1,
# otherwise skip to next atom 
if ( $atom2 =~ /C(6)/ and $nameskip =~ /RC/ ) {
$atom1 = "C$1";

} else {
next;
}

seek PDB,0,0;

# If first argument succeeds, the second will never be executed 
if (($atom1 eq "C6") || ($atom2 eq "C6"))  {
LOOK: while (<PDB>)  { 
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "C6")  {
# First variable in output file is the atom number  
$c = $atomnum;
}
}
}
}
# Second variable in output file as first atom coordinate derived from the PDB file
#$c5 = $c + 2;
seek PDB,0,0;
LOOK: while (<PDB>) {
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "C5"){
$c5=$atomnum;
}
}
}
# Third variable in output file as the second atom coordinate derived from the PDB file
#$c4 = $c + 4;
seek PDB,0,0;
LOOK: while (<PDB>) {
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "C4"){
$c4=$atomnum;
}
}
}

$tot++;

printf CSAOUT "  jcsa(%d)=%d, icsa(%d)=%d, kcsa(%d)=%d, cobsl(%d)= %5.2f, cobsu(%d)= %5.2f, \n",
$tot, $c, $tot, $c5, $tot, $c4, $tot, ($csa-$range), $tot, ($csa+$range);
}
$cc6=$tot-($allc8+$allc2);

######U-C6###############################C5(+2)####C4(+4)##########################################

seek CSA,0,0;


# Input Ramah CSA variables
while (<CSA>)  {
($Cskip, $atom2, $res, $nameskip, $csa) = split;

# skip lines that begin with #(comments)
if ( $res =~ /#.*/ ) {
next;
}
# now if atom2 matches C6, then name corresponding atom1,
# otherwise skip to next atom 
if ( $atom2 =~ /C(6)/ and $nameskip =~ /RU/ ) {
$atom1 = "C$1";

} else {
next;
}

seek PDB,0,0;

# If first argument succeeds, the second will never be executed 
if (($atom1 eq "C6") || ($atom2 eq "C6"))  {
LOOK: while (<PDB>)  { 
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "C6")  {
# First variable in output file is the atom number  
$c = $atomnum;
}
}
}
}
# Second variable in output file as first atom coordinate derived from the PDB file
#$c5 = $c + 2;
seek PDB,0,0;
LOOK: while (<PDB>) {
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "C5"){
$c5=$atomnum;
}
}
}
# Third variable in output file as the second atom coordinate derived from the PDB file
#$c4 = $c + 4;
seek PDB,0,0;
LOOK: while (<PDB>) {
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "C4"){
$c4=$atomnum;
}
}
}

$tot++;

printf CSAOUT "  jcsa(%d)=%d, icsa(%d)=%d, kcsa(%d)=%d, cobsl(%d)= %5.2f, cobsu(%d)= %5.2f, \n",
$tot, $c, $tot, $c5, $tot, $c4, $tot, ($csa-$range), $tot, ($csa+$range);
}
$uc6=$tot-($allc8+$allc2+$cc6);
$allc6=$uc6+$cc6;

######C-C5###############################H5(+1)###C6(-2)###########################################
seek CSA,0,0;

# Input Ramah CSA variables
while (<CSA>)  {
($Cskip, $atom2, $res, $nameskip, $csa) = split;

# skip lines that begin with #(comments)
if ( $res =~ /#.*/ ) {
next;
}
# now if atom2 matches C5, then name corresponding atom1,
# otherwise skip to next atom 
if ( $atom2 =~ /C(5)/ and $nameskip =~ /RC/ ) {
$atom1 = "C$1";

} else {
next;
}

seek PDB,0,0;

# If first argument succeeds, the second will never be executed  
if (($atom1 eq "C5") || ($atom2 eq "C5"))  {
LOOK: while (<PDB>)  { 
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "C5")  {
# First variable in output file is the atom number  
$c = $atomnum;
}
}
}
}
# Second variable in output file as first atom coordinate derived from the PDB file
#$h5 = $c + 1;
seek PDB,0,0;
LOOK: while (<PDB>) {
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "H5"){
$h5=$atomnum;
}
}
}
# Third variable in output file as the second atom coordinate derived from the PDB file
#$c6 = $c - 2;
seek PDB,0,0;
LOOK: while (<PDB>) {
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "C6"){
$c6=$atomnum;
}
}
}

$tot++;

printf CSAOUT "  jcsa(%d)=%d, icsa(%d)=%d, kcsa(%d)=%d, cobsl(%d)= %5.2f, cobsu(%d)= %5.2f, \n",
$tot, $c, $tot, $h5, $tot, $c6, $tot, ($csa-$range), $tot, ($csa+$range);
}
$cc5=$tot-($allc8+$allc2+$allc6);

######U-C5###############################H5(+1)###C6(-2)############################################

seek CSA,0,0;


# Input Ramah CSA variables
while (<CSA>)  {
($Cskip, $atom2, $res, $nameskip, $csa) = split;

# skip lines that begin with #(comments)
if ( $res =~ /#.*/ ) {
next;
}
# now if atom2 matches C5, then name corresponding atom1,
# otherwise skip to next atom 
if ( $atom2 =~ /C(5)/ and $nameskip =~ /RU/ ) {
$atom1 = "C$1";

} else {
next;
}

seek PDB,0,0;

# If first argument succeeds, the second will never be executed  
if (($atom1 eq "C5") || ($atom2 eq "C5"))  {
LOOK: while (<PDB>)  { 
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "C5")  {
# First variable in output file is the atom number  
$c = $atomnum;
}
}
}
}
# Second variable in output file as first atom coordinate derived from the PDB file
#$h5 = $c + 1;
seek PDB,0,0;
LOOK: while (<PDB>) {
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "H5"){
$h5=$atomnum;
}
}
}
# Third variable in output file as the second atom coordinate derived from the PDB file
#$c6 = $c - 2;
seek PDB,0,0;
LOOK: while (<PDB>) {
($a, $atomnum, $atomname, $resname, $resnum) = split;
if ($resnum == $res)  {
if ($atomname eq "C6"){
$c6=$atomnum;
}
}
}

$tot++;

printf CSAOUT "  jcsa(%d)=%d, icsa(%d)=%d, kcsa(%d)=%d, cobsl(%d)= %5.2f, cobsu(%d)= %5.2f, \n",
$tot, $c, $tot, $h5, $tot, $c6, $tot, ($csa-$range), $tot, ($csa+$range);
}
$uc5=$tot-($allc8+$allc2+$allc6+$cc5);
$allc5=$cc5+$uc5;
close(CSAOUT);

open (CSAOUT, ">> RST1.csa");
printf CSAOUT " &end\n";
close (CSAOUT);

###################################HEADER#################################################

$r=$tot;
open (CSAOUT, ">RST.csa");

printf CSAOUT "#   C2/C8/C6/C5 pseudo-CSA's for cswap32-45 dimer, values in Hz for 13C=150 MHz
#
#   How to set up the sigma and {i,j,k}csa arrays:
#
#   For C8-H8 (G):    sigma{11,22} =  5.,  74.,  {i,j,k}csa = N7, C8, N9
#   For C8-H8 (A):    sigma{11,22} =  5.,  80.,  {i,j,k}csa = N7, C8, N9
#   For C2-H2 (A):    sigma{11,22} = 89.,  15.,  {i,j,k}csa = H2, C2, N1
#   For C6-H6 (C/U):  sigma{11,22} = -3., 121.,  {i,j,k}csa = C5, C6, C4
#   For C5-H5 (C/U):  sigma{11,22} = 82.,   2.,  {i,j,k}csa = H5, C5, C6
#
#
#  Values are those of Ying et al. JACS 128: 11443 (2006), (Table 1),
#  idealized to diagonal tensors with one principal axis along a local
#  bond direction.
#     (need to relax this limitation)
#
#	Program written at UMBC, Dept. of Chemistry by Holly R. Summers, September 9, 2008
# \n";

printf CSAOUT" &csa
  ncsa=$r, cwt=$r*0.1,
  sigma11=$allc8*5., $allc2*89., $allc6*-3., $allc5*82.,
  sigma22=$gc8*74., $ac8*80., $allc2*15., $allc6*121., $allc5*2.,
  sigma12=$r*0., sigma13=$r*0., sigma23=$r*0.,
  field=$r*150.0, \n";
close (CSAOUT);
####################Catonate##Output##File##To###Header###########################################
#Opening File with header
open(CSAOUT, ">>RST.csa") or die "Could not open RST.csa file: $!";
#Opening File with Restraints
open(CSAIN, "<RST1.csa") or die "Could not open RST1.csa file: $!";
#Appending restraints file to header file
while ( my $line = <CSAIN> ) { printf CSAOUT $line; } 

unlink("RST1.csa");
#Closing Restraint File
close (CSAIN);

#Closing input files ramah.csa file and amber.pdb file
close(CSA);
close(PDB);
#Closing output file with header RST.csa
close(CSAOUT);

