#!/usr/bin/perl
if ($#ARGV < 0) { die "

USAGE: $0 -s 344 345 439 temp.pdb      subtract from res. number

    344 add or subtract this value from residue number
      1 start renumbering from this residue 
     98 end renumbering at this residue

\n"
}; 

use Getopt::Std;
getopts('ars');

if ($opt_a) {
    $file  = $ARGV[0];                      #last entry is filename
} else {
    $value = $ARGV[0];
    $start = $ARGV[1];
    $end   = $ARGV[2];
    $file  = $ARGV[3];                      #last entry is filename
    $value = (-1*$value) if ($opt_s);
}

open (IN, $file) or die "Can't open $file\n";

ten_column_pdb() unless($opt_a or $opt_r);       #use for 8 and 10 column pdbs 

close (IN);                   

sub ten_column_pdb {           #amber outputs an 8 column pdb; molmol 10 cols
  LINE:  while (<IN>) {
	if (/^#|^\s*$/) {
           next LINE;
         } else {
	    $_ =~ s/URA/U  /;
      	    $_ =~ s/RGUA/ G  /;
      	    $_ =~ s/RADE/ A  /;
      	    $_ =~ s/RAD\+/ A  /;
      	    $_ =~ s/RCYT/ C  /;
    
	    @v = split(' ',$_);		 #split the line
	    $res = $v[0];
	    $res += $value if ($res >= $start and $res <= $end);

	    printf "%5d %6s %6s %5s %6s", $res, $v[1], $v[2], $v[3], $v[4];
	    
	    print "\n";
        }
    }
}                   
