#!/usr/bin/perl 
if ($#ARGV ne 3) { die "
USAGE 2: renumberupl.pl 344  1 95 uplfile      add 344 to residues 1 to 95 
USAGE 2: renumberupl.pl -344 1 95 uplfile      subtract 344 from residues 1-95
       
      344  value to be subtracted or added
        1  beginning of residue number to be changed
       95  ending residue number to be changed

may 26 2003 fixed to keep the notes after each upl entry

\n";
} 

$value = $ARGV[0];
$begin = $ARGV[1];
$end   = $ARGV[2];
$file  = $ARGV[3];

#print "$value $begin $end $file debugger \n";  exit;

open(IN, $file) or die "Can't open $file\n";          #open upl file
while (<IN>) {
    $_ =~ s/^\s+//;                 #remove trailing blanks
    if (/^[0-9]/) {                 #if line starts with a digit
	@v = split(' ', $_);        #split by space

	$v[0] = $v[0] + $value if ($v[0] >= $begin and $v[0] <= $end);
	$v[3] = $v[3] + $value if ($v[3] >= $begin and $v[3] <= $end);

	printf "%3s %3s %-4s", $v[0], $v[1], $v[2]; 
	printf "%7s %3s %-4s ", $v[3], $v[4], $v[5]; 
	printf "%10s", $v[6];

        print "   #   ";

	if ($#v > 6) {                # there are comments
	    $i=8;                     # 7th is #
	    while ($i <= $#v) {
	        print "$v[$i] ";
		$i++;
	    }
	}

	print "\n";
    } else {
	print;    # print lines that do not start with a digit unmodified
                  # these are the comments
    }
}
close(IN);


